<html>
<body>

<H2 autotoc="yes"> Alien file formats: common </H2>
<p>
This section deals with some common aspects on handling alien (non-native)
file formats (load/save, import/export).

<H3 autotoc="yes"> Sheet load postproc: config </H3>
<p>
The data model of different schematics capture tools differ a lot. Most
notably the name and interpretation of attributes vary. A typical example
is: geda/gschem uses the <b>refdes</b> attribute to name symbols while
sch-rnd uses the <b>name</b> attribute. Loading a gschem sheet
(using the io_geda plugin) won't result in a netlistable sheet without renaming
all refdes attributes to name attributes.
<p>
sch-rnd provides a flexible, configurable sheet postprocessing. When an io_
plugin supports it, it has a list type config node called <i>postproc_sheet_load</i>,
which contains pattern-action pairs. The pattern is a valid query script that
is ran on the concrete model of the sheet after load. Whenever it yields
a matching object, the object is marked and the corresponding action is executed.
The action is expected to make the necessary modification on the marked object.
<p>
For example above refdes-to-name translation for io_geda is configured in
two pairs in config node plugins.io_geda.postproc_sheet_load:

<pre>
{(@.a.refdes != "")};                                {propset(@, rename/a/refdes, name)}
{(@.type == TEXT)  &amp;&amp; (@.text == "%../A.refdes%")};  {propset(@, p/text/text, "%../A.name%")}
</pre>

<p>
The first one runs on any object that has a non-empty refdes attribute. It
does not have to check for the object being a group (GRP), because only groups
have attribute in our model.
<p>
If it triggers, the group (typically symbol) has a refdes attribute, the
corresponding action, a propset() is ran. The first argument of the
propset is @, which defines the scope to be the object marked. Without
this scoping, propset would run on all selected objects, which would also
work because the code also makes sure only the marked object is selected, however
searching for selection is time consuming. Then the propset goes and
renames the refdes attribute to name.
<p>
The second rule edits the text string of attribute printout floaters. These
floaters are dyntext and refer to the attribute by attribute name, which was
originally <i>refdes</i>. The query expression matches text objects that
have the exact reference text insertedby io_geda for the refdes attribute.
The corresponding propset action simply changes the value of the text string
to refer to the name attribute.
<p>
There is no limit on how many pattern-action pairs can be configured. However,
it will take time to run all them after each sheet load from the given format.
The pairs are executed in order; the config node is an ordered list, config
files can use 
<a href="http://www.repo.hu/projects/librnd/conf/lists.html">
prepend or append subtrees</a> to modify an existing list without
overwriting it.
<p>
Whether a given io_ plugin supports sheet postproc or not depends on
whehter it has the <i>postproc_sheet_load</i> node defined in its config
subtree.

<H3 autotoc="yes"> Sheet load postproc: generic scripting </H3>
<p>
An alternative to the above configured sheet post processing is using
an user script. After the above mechanism ran, the code also calls the
an action whose name is the io plugin's name suffixed with _postproc_sheet_load.
For example loading a gschem sheet with io_geda, the action name is
<i>io_geda_postproc_sheet_load</i>. No error is thrown if the action does not
exist.
<p>
The action then can be implemented in a plugin or in an user script and
go and visit and modify object in any order and with any method it sees fit.
<p>
Limitations:
<ul>
	<li> Only one action per io plugin can be registered, so if there are two scripts
	     providing the io_geda_postproc_sheet_load action, only one will run
	<li> With librnd 4.0.0 there is a limitation that will be fixed later:
	     permascripts are not loaded before the sheet if the sheet is loaded
	     from the command line. This means an user script action postprocessor
	     will work only when the sheet is loaded from the GUI.
	     <!--TODO#1-->
</ul>
